
package dev.sonpx.loyalty.mcp.reward.enums;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonPropertyDescription;
import com.fasterxml.jackson.annotation.JsonValue;
import java.util.Arrays;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

/**
 * Created by SonPhung on Monday, 20-Jul-2026
 */
@Getter
@RequiredArgsConstructor
public enum BaseDateType {

    @JsonPropertyDescription("Ngày hệ thống ghi nhận giao dịch")
    POST_DATE("PD"),

    @JsonPropertyDescription("Ngày khách hàng thực hiện giao dịch")
    TRANSACTION_DATE("TD");

    @JsonValue
    private final String code;

    @JsonCreator
    public static BaseDateType fromCode(String code) {
        return Arrays.stream(values())
                .filter(e -> e.code.equalsIgnoreCase(code))
                .findFirst()
                .orElse(null);
    }
}
